#define NUM2STR_UID	0
#define NUM2STR_GID	1


struct num2str{
	atomic_t count;
	u_int type; /* UID, GID, PRINCIPAL */
	u_int num;
	utf8string str;
};

struct num_struct {
	struct num_struct *next, **pprev;
	struct num2str *data;
	int namehashent;
};

struct name_struct {
	struct name_struct *next, **pprev;
	struct num2str *data;
};

int num2str(int num, int type, char *buf, int *size);
int str2num(u_int *num, u_int type, utf8string *str);
int get_num(u_int type, utf8string *str, u_int *num);
int get_name(u_int type, u_int num, utf8string *str);
